''' -----------------------------------------------------------------------------
''' Project	 : NHenry.Exception
''' Class	 : Exception.ColParams
''' -----------------------------------------------------------------------------
''' <summary>
''' Classe collection des structures SParam
''' </summary>
''' -----------------------------------------------------------------------------
<System.Reflection.DefaultMember("Item")> Public NotInheritable Class ColParams
    Inherits CollectionBase

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Constructeur de la classe
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Sub New()
        MyBase.New()
    End Sub
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Ajoute un lment  la liste
    ''' </summary>
    ''' <param name="pParam">Structure  ajouter</param>
    ''' <returns></returns>
    ''' -----------------------------------------------------------------------------
    Public Function Add(ByVal pParam As SParam) As SParam
        MyBase.InnerList.Add(pParam)
        Return pParam
    End Function
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Ajoute un lment  la liste
    ''' </summary>
    ''' <param name="pName">Nom du paramtre</param>
    ''' <param name="pObj">Valeur du paramtre</param>
    ''' <returns></returns>
    ''' -----------------------------------------------------------------------------
    Public Function Add(ByVal pName As String, ByVal pObj As Object) As SParam
        Return Add(New SParam(pName, pObj))
    End Function
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne ou dfinit la structure  l'index spcifi
    ''' </summary>
    ''' <param name="pIndex">Index de la valeur</param>
    ''' <value></value>
    ''' -----------------------------------------------------------------------------
    Public Property Item(ByVal pIndex As Integer) As SParam
        Get
            Return CType(MyBase.InnerList.Item(pIndex), SParam)
        End Get
        Set(ByVal Value As SParam)
            MyBase.InnerList.Item(pIndex) = Value
        End Set
    End Property
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne ou dfinit la structure  l'index spcifi
    ''' </summary>
    ''' <param name="pStr">Objet  rechercher</param>
    ''' <value></value>
    ''' -----------------------------------------------------------------------------
    Public ReadOnly Property Item(ByVal pStr As String) As SParam
        Get
            Dim lParam As SParam
            For Each lParam In MyBase.InnerList
                If lParam.Name.ToLower.IndexOf(pStr.ToLower) <> -1 Then
                    Return lParam
                End If
            Next
            Return Nothing
        End Get
    End Property
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Supprime une structure de la liste
    ''' </summary>
    ''' <param name="pParam">Structure  supprimer</param>
    ''' -----------------------------------------------------------------------------
    Public Sub Remove(ByVal pParam As SParam)
        MyBase.InnerList.Remove(pParam)
    End Sub
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne une chaine reprsentant l'objet est ses contenus
    ''' </summary>
    ''' <returns></returns>
    ''' -----------------------------------------------------------------------------
    Public Overrides Function ToString() As String
        Dim lStr As String = "ColParams, Count=" + CStr(MyBase.Count) + ", Items :" + Environment.NewLine
        Dim lParam As SParam
        For Each lParam In Me
            lStr += "  " + lParam.ToString + Environment.NewLine
        Next
        Return lStr
    End Function
End Class
